src/main/java/org/example/bean/DataRepositoryProducer.java
package org.example.bean;

import javax.ejb.Stateless;
import javax.enterprise.context.ConversationScoped;
import javax.enterprise.inject.Produces;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.example.qualifier.DataRepository;

/**
 * This is the stateless EJB that produced our {@link EntityManager} instance.
 * This EJB has an entity manager injected and we return it to CDI in our
 * {@link Produces} annotated method. We qualify the producer with the
 * {@link DataRepository} qualifier.
 * 
 */
@Stateless
public class DataRepositoryProducer {
	
	
	private EntityManager entityManager;
	
	@Produces @DataRepository @ConversationScoped
	public EntityManager getEntityManager() {
		return entityManager;
	}
	
	@PersistenceContext
	public void setEntityManager(EntityManager entityManager) {
		this.entityManager = entityManager;
	}

}

src/main/java/org/example/bean/PersonDao.java
package org.example.bean;

import org.example.model.Person;
import org.example.qualifier.DataRepository;

import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.TypedQuery;
import java.util.List;

/**
 * Simple PersonDao bean that handles persisting a person entity and returning a
 * list of people in the database. Implemented as an EJB for the transaction
 * facilities.
 */
@Stateless
public class PersonDao {

    @Inject
    @DataRepository
    private EntityManager entityManager;

    public void savePerson(Person p) {
        entityManager.persist(p);
    }

    @SuppressWarnings("unchecked")
    public List<Person> getPeople() {
        return entityManager.createQuery("select p from Person p")
                .getResultList();
    }


    /**
     * For ALl Queries Code completion is working, refactoring when renaming Entity properties is working.
     *
     * QueryParam Name checking and Refactoring not working when using NamedQueries
     */

    public Person getPersonForIdNamedEntity(Long id) {
        //will show error when nam9e is not correct
        TypedQuery<Person> query = entityManager.createNamedQuery("testNamedEntity", Person.class);
        TypedQuery<Person> query2 = entityManager.createNamedQuery("testNamedEntityyyy", Person.class);

        //will not refactor when Action -> Renaming :id in query
        query.setParameter("id", id);

        //does produce 'Cannot resolve query parameter 'idd'
         query.setParameter("idd", id);
        return query.getSingleResult();
    }

    public Person getPersonForIdNamedXML(Long id) {
        // will show error when name is not correct
        TypedQuery<Person> query = entityManager.createNamedQuery("testNamedXML", Person.class);
         TypedQuery<Person> query2 = entityManager.createNamedQuery("testNamedXMLLLL", Person.class);
        //will not refactor when Action -> Renaming :id in query
        query.setParameter("id", id);

        //does not produce 'Cannot resolve query parameter 'idd'
         query.setParameter("idd", id);
        return query.getSingleResult();
    }

    public Person getPersonForIdDynamic(Long id) {
        TypedQuery<Person> query = entityManager.createQuery("select p from Person p where p.id = :id", Person.class);
        // will refactor when Action -> Renaming :id in query
        query.setParameter("id", id);

        // produces "Cannot resolve query parameter 'idd'"
         query.setParameter("idd", id);
        return query.getSingleResult();
    }
}

src/main/java/org/example/model/Person.java
package org.example.model;

import org.hibernate.validator.constraints.NotEmpty;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@NamedQuery(name = "testNamedEntity", query = "select p from Person p where p.id = :id")
@Entity
@Table(name = "PERSONS")
public class Person {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column(length = 25)
    @Size(max = 25)
    @NotNull
    @NotEmpty
    private String firstName;

    @Column(length = 25)
    @Size(max = 25)
    @NotNull
    @NotEmpty
    private String lastName;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

}

src/main/java/org/example/view/HelloBean.java
package org.example.view;

import javax.enterprise.context.RequestScoped;
import javax.inject.Named;

@Named("helloBean")
@RequestScoped
public class HelloBean {

	
	private String name;

	public String getMessage() {
		if (name == null) {
			return "Enter your name above";
		}
		return "Hello there " + name;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getHelloMessage() {
		return "Hello World!";
	}
}

src/main/java/org/example/view/PersonBean.java
package org.example.view;

import java.util.List;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.example.model.Person;
import org.example.bean.PersonDao;


@Named("personBean")
@RequestScoped
public class PersonBean {

	@Inject 
	private PersonDao personDao;	
	
	private Person person = new Person();
	
	public void savePerson() {
		personDao.savePerson(person);
		//once saved, we want to clear the values
		person = new Person();
	}
	
	public List<Person> getPeople() {
		return personDao.getPeople();
	}
	
	public Person getPerson() {
		return person;
	}
	
	public void setPerson(Person person) {
		this.person = person;
	}
}

src/main/webapp/WEB-INF/templates/template.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:ui="http://java.sun.com/jsf/facelets">
<h:head>
	<title>${project.artifactId} Application</title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<h:outputStylesheet name="css/screen.css" />
</h:head>
<h:body>
	<h:panelGroup id="page" layout="block">
		<h:panelGroup id="header" layout="block">
			<h1><a href="home.jsf">JpaFacetXmlNamedquerySupport</a></h1>
		</h:panelGroup>
		<h:panelGroup id="container" layout="block">
			<h:panelGroup id="sidebar" layout="block">

				<h1>Sidebar</h1> Content for the sidebar goes here
			
			</h:panelGroup>
			<h:panelGroup id="content" layout="block">
				<ui:insert name="content">Main Content</ui:insert>
			</h:panelGroup>
		</h:panelGroup>
		<h:panelGroup id="footer" layout="block">#{messages.footerText}<br/>Generated using the Knappsack Java EE Maven Archetypes from <a href="http://www.AndyGibson.net">www.AndyGibson.net</a></h:panelGroup>
	</h:panelGroup>

</h:body>
</html>

src/main/webapp/home.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	template="/WEB-INF/templates/template.xhtml">
	<ui:define name="content">
		<h:panelGroup layout="block" styleClass="panel">
			<h1>Access CDI bean from JSF</h1>
		Your CDI bean <code>helloBean</code> says "#{helloBean.helloMessage}"<br />
			<br />
		</h:panelGroup>
		<h:form id="helloForm">

			<h:panelGroup layout="block" styleClass="panel">
				<h1>JSF interacting with CDI</h1>
      Enter Name<br />
				<h:inputText value="#{helloBean.name}" />
				<br />
				<h:commandButton value="Submit" />
				<br />
      Message : <h:outputText value="#{helloBean.message}" />
			</h:panelGroup>
		</h:form>

		<h:panelGroup layout="block" styleClass="panel">
			<h1>JPA, CDI, JSF and Validation</h1>
			<small>Try leaving values blank or making them longer than 25
			chars</small>
			<br />
			<br />

			<h:form id="personEdit">
      			FirstName<br />
				<h:inputText value="#{personBean.person.firstName}" id="firstName" style="margin-right : 8px"/>
				<h:message for="firstName" styleClass="errorMessage" />
				<br />
				<br />      
			      LastName<br />
				<h:inputText value="#{personBean.person.lastName}" id="lastName" style="margin-right : 8px"/>
				<h:message for="lastName" styleClass="errorMessage" />
				<br />
				<br />
				<h:commandButton value="Add" action="#{personBean.savePerson}" />
			</h:form>
			<br />
			<small>The validation logic is coming from the annotations
			we added to the model</small>			

			<h3 style="text-decoration: underline;">List of People</h3>
			<ui:repeat var="v_person" value="#{personBean.people}">
		#{v_person.firstName} #{v_person.lastName}<br />
			</ui:repeat>
		</h:panelGroup>
	</ui:define>
</ui:composition>